/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// TxOutputsData struct for TxOutputsData
type TxOutputsData struct {
	// The status of the given transaction output.
	Status *string `json:"status,omitempty"`
	// Whether the transaction output was spent or not.
	IsSpent *bool `json:"is_spent,omitempty"`
	// The amount of tokens within the given output.
	Value   *int64            `json:"value,omitempty"`
	Spent   *TxOutputResponse `json:"spent,omitempty"`
	Mined   *TxOutputResponse `json:"mined,omitempty"`
	Pending *TxOutputResponse `json:"pending,omitempty"`
}

// NewTxOutputsData instantiates a new TxOutputsData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTxOutputsData() *TxOutputsData {
	this := TxOutputsData{}
	return &this
}

// NewTxOutputsDataWithDefaults instantiates a new TxOutputsData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTxOutputsDataWithDefaults() *TxOutputsData {
	this := TxOutputsData{}
	return &this
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *TxOutputsData) GetStatus() string {
	if o == nil || o.Status == nil {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputsData) GetStatusOk() (*string, bool) {
	if o == nil || o.Status == nil {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *TxOutputsData) HasStatus() bool {
	if o != nil && o.Status != nil {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *TxOutputsData) SetStatus(v string) {
	o.Status = &v
}

// GetIsSpent returns the IsSpent field value if set, zero value otherwise.
func (o *TxOutputsData) GetIsSpent() bool {
	if o == nil || o.IsSpent == nil {
		var ret bool
		return ret
	}
	return *o.IsSpent
}

// GetIsSpentOk returns a tuple with the IsSpent field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputsData) GetIsSpentOk() (*bool, bool) {
	if o == nil || o.IsSpent == nil {
		return nil, false
	}
	return o.IsSpent, true
}

// HasIsSpent returns a boolean if a field has been set.
func (o *TxOutputsData) HasIsSpent() bool {
	if o != nil && o.IsSpent != nil {
		return true
	}

	return false
}

// SetIsSpent gets a reference to the given bool and assigns it to the IsSpent field.
func (o *TxOutputsData) SetIsSpent(v bool) {
	o.IsSpent = &v
}

// GetValue returns the Value field value if set, zero value otherwise.
func (o *TxOutputsData) GetValue() int64 {
	if o == nil || o.Value == nil {
		var ret int64
		return ret
	}
	return *o.Value
}

// GetValueOk returns a tuple with the Value field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputsData) GetValueOk() (*int64, bool) {
	if o == nil || o.Value == nil {
		return nil, false
	}
	return o.Value, true
}

// HasValue returns a boolean if a field has been set.
func (o *TxOutputsData) HasValue() bool {
	if o != nil && o.Value != nil {
		return true
	}

	return false
}

// SetValue gets a reference to the given int64 and assigns it to the Value field.
func (o *TxOutputsData) SetValue(v int64) {
	o.Value = &v
}

// GetSpent returns the Spent field value if set, zero value otherwise.
func (o *TxOutputsData) GetSpent() TxOutputResponse {
	if o == nil || o.Spent == nil {
		var ret TxOutputResponse
		return ret
	}
	return *o.Spent
}

// GetSpentOk returns a tuple with the Spent field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputsData) GetSpentOk() (*TxOutputResponse, bool) {
	if o == nil || o.Spent == nil {
		return nil, false
	}
	return o.Spent, true
}

// HasSpent returns a boolean if a field has been set.
func (o *TxOutputsData) HasSpent() bool {
	if o != nil && o.Spent != nil {
		return true
	}

	return false
}

// SetSpent gets a reference to the given TxOutputResponse and assigns it to the Spent field.
func (o *TxOutputsData) SetSpent(v TxOutputResponse) {
	o.Spent = &v
}

// GetMined returns the Mined field value if set, zero value otherwise.
func (o *TxOutputsData) GetMined() TxOutputResponse {
	if o == nil || o.Mined == nil {
		var ret TxOutputResponse
		return ret
	}
	return *o.Mined
}

// GetMinedOk returns a tuple with the Mined field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputsData) GetMinedOk() (*TxOutputResponse, bool) {
	if o == nil || o.Mined == nil {
		return nil, false
	}
	return o.Mined, true
}

// HasMined returns a boolean if a field has been set.
func (o *TxOutputsData) HasMined() bool {
	if o != nil && o.Mined != nil {
		return true
	}

	return false
}

// SetMined gets a reference to the given TxOutputResponse and assigns it to the Mined field.
func (o *TxOutputsData) SetMined(v TxOutputResponse) {
	o.Mined = &v
}

// GetPending returns the Pending field value if set, zero value otherwise.
func (o *TxOutputsData) GetPending() TxOutputResponse {
	if o == nil || o.Pending == nil {
		var ret TxOutputResponse
		return ret
	}
	return *o.Pending
}

// GetPendingOk returns a tuple with the Pending field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TxOutputsData) GetPendingOk() (*TxOutputResponse, bool) {
	if o == nil || o.Pending == nil {
		return nil, false
	}
	return o.Pending, true
}

// HasPending returns a boolean if a field has been set.
func (o *TxOutputsData) HasPending() bool {
	if o != nil && o.Pending != nil {
		return true
	}

	return false
}

// SetPending gets a reference to the given TxOutputResponse and assigns it to the Pending field.
func (o *TxOutputsData) SetPending(v TxOutputResponse) {
	o.Pending = &v
}

func (o TxOutputsData) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Status != nil {
		toSerialize["status"] = o.Status
	}
	if o.IsSpent != nil {
		toSerialize["is_spent"] = o.IsSpent
	}
	if o.Value != nil {
		toSerialize["value"] = o.Value
	}
	if o.Spent != nil {
		toSerialize["spent"] = o.Spent
	}
	if o.Mined != nil {
		toSerialize["mined"] = o.Mined
	}
	if o.Pending != nil {
		toSerialize["pending"] = o.Pending
	}
	return json.Marshal(toSerialize)
}

type NullableTxOutputsData struct {
	value *TxOutputsData
	isSet bool
}

func (v NullableTxOutputsData) Get() *TxOutputsData {
	return v.value
}

func (v *NullableTxOutputsData) Set(val *TxOutputsData) {
	v.value = val
	v.isSet = true
}

func (v NullableTxOutputsData) IsSet() bool {
	return v.isSet
}

func (v *NullableTxOutputsData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTxOutputsData(val *TxOutputsData) *NullableTxOutputsData {
	return &NullableTxOutputsData{value: val, isSet: true}
}

func (v NullableTxOutputsData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTxOutputsData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
